Subject: bug#50732: 28.0.50; project-find-dir: blank line in fido-vertical-mode

From: Juri Linkov <[email-masked]>
Date: Wed, 22 Sep 2021 19:51:34 +0300

>> > Please don't change project-find-dir, it has no problem.
>> > The problem is in fido-vertical-mode.
>>
>> DId you miss the part where I showed that the *Completions*
>> buffer also displays an unselectable empty string?

I confirm that the *Completions* buffer can't select it, and I've never
seen completions with an empty string.  So indeed why project-find-dir
should add it?  Maybe the problem is in project--read-file-cpd-relative?
Other completion functions allow typing RET to accept an empty string
as the default value.  Why project--read-file-cpd-relative can't do this?

>> Why not do what `M-x dired` does? Dired users would appreciate
>> the consistency, regardless of the completion UI they use.

In Dired directory names are absolute, but in project-find-dir
are relative.  Regarding your suggestion about `./`, I guess
it could be used when project--read-file-cpd-relative can't do better.

> Regardless (I really think you should do the above), I don't object
> to adding your "<empty>" idea to Icomplete and everywhere else
> in Emacs that is affected by this.  At least I don't see any immediate
> problems with that idea.  So the two things aren't mutually exclusive.

I don't know if empty strings make sense as completion candidates.